############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package Common::NXProcess;no warnings;($NXProcess::children={});(
$NXProcess::childrenData={});($NXProcess::finishedChildren={});(
$NXProcess::childFinishedWithSignal={});($NXProcess::childrenExitCallback={});(
$NXProcess::childrenErrorCallback={});($NXProcess::childrenToLeave={});(
$NXProcess::watchDogList={});($NXProcess::finishedWatchDogList={});(
$NXProcess::watchDogToLeaveList={});($NXProcess::watchDogAsSuperuser={});(
$NXProcess::errorNoProcessToWait=(-(0x0828+ 2627-0x126a)));(
$NXProcess::statusRunning=(0x01ca+ 3688-0x1032));($NXProcess::statusExited=
(0x0c5f+ 1889-0x13bf));($NXProcess::signalKill=(0x07dd+ 2249-0x109d));(
$NXProcess::signalTerm=(0x16c0+ 1450-0x1c5b));($NXProcess::signalSegv=
(0x12dc+ 3656-0x2119));($NXProcess::processTree=(0x0009+ 9931-0x26d3));(
$NXProcess::noProcessTree=(0x0a29+ 1368-0x0f81));sub nxProcessCreate{(my $filename
=shift (@_));(my $command=shift (@_));(my $environment=shift (@_));(my $stdin=
shift (@_));(my $stdout=shift (@_));(my $stderr=shift (@_));(my $priority=shift 
(@_));my ($pid);my ($pidOrHandle);Logger::debug (((((((((((((((
"\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x3a\x20\x27".
$filename)."\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",
@$environment))."\x27\x20\x27\x46\x44\x23").$stdin)."\x27\x20\x27\x46\x44\x23").
$stdout)."\x27\x20\x27\x46\x44\x23").$stderr)."\x27\x20\x27").$priority)."\x27")
);($pidOrHandle=libnxh::NXProcessCreate ($filename,$command,$environment,$stdin,
$stdout,$stderr,$priority));if (($pidOrHandle==(-(0x0f2f+ 4072-0x1f16)))){
Common::NXCore::reportErrorFromNXPL (((((((((((((((((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment)."\x2c\x20").$stdin)."\x2c\x20").
$stdout)."\x2c\x20").$stderr)."\x2c\x20").$priority).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$pidOrHandle)."\x2e"));return ((-(0x15a0+ 3098-0x21b9)));}($pid=
handleProcessHandle ($pidOrHandle));addChild ($pid);(my $commandLine=$filename);
foreach my $parameter (@$command){if (($parameter eq $filename)){next;}else{(
$commandLine.=("\x20".$parameter));}}registerChildName ($commandLine,$pid);
return ($pid);}sub nxProcessExec{(my $filename=shift (@_));(my $command=shift (
@_));(my $environment=shift (@_));(my $ref_error=shift (@_));Logger::debug (((((
(("\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x3a\x20\x27".$filename).
"\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",@$environment)).
"\x27"));(my $result=libnxh::NXProcessExec ($filename,$command,$environment));if
 (($result==(-(0x07b9+ 5274-0x1c52)))){Common::NXCore::reportErrorFromNXPL (((((
(((("\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$result)."\x2e"));($$ref_error=libnxh::NXGetErrorString ());return (
(0x0284+ 897-0x0605));}return ((0x1799+ 590-0x19e6));}sub handleProcessHandle{(my $pidOrHandle
=shift (@_));return ($pidOrHandle);(my $pid=getPidFromHandle ($pidOrHandle));(
$NXProcess::processPidsArrayByHandle{$pidOrHandle}=$pid);(
$NXProcess::processHandlesArrayByPid{$pid}=$pidOrHandle);return ($pid);}sub 
getPidFromHandle{(my $handle=shift (@_));(my $pid=libnxh::NXConvertHandlerToPid 
($handle));Logger::debug (((((
"\x67\x65\x74\x50\x69\x64\x46\x72\x6f\x6d\x48\x61\x6e\x64\x6c\x65\x3a\x20\x68\x61\x6e\x64\x6c\x65\x20\x5b"
.$handle).
"\x5d\x20\x63\x6f\x6e\x76\x65\x72\x74\x65\x64\x20\x74\x6f\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d\x2e"));return ($pid);}sub convertToHandleIfNeeded{(my $pid=shift (
@_));return ($pid);if (defined ($NXProcess::processHandlesArrayByPid{$pid})){(my $handle
=$NXProcess::processHandlesArrayByPid{$pid});if (($pid==
$NXProcess::processPidsArrayByHandle{$handle})){return ($handle);}}return ($pid)
;}sub checkIsProcessFinished{(my $pid=shift (@_));if (($pid>(0x00f7+ 522-0x0301)
)){if ((not (isChildProcess ($pid)))){if (isChildFinished ($pid)){return (
(0x0582+ 3810-0x1463));}if ((not (isOnWatchdogProcess ($pid)))){if (
isFinishedWatchDog ($pid)){return ((0x1568+ 1333-0x1a9c));}return ((-
(0x13b1+ 119-0x1427)));}}}if (($pid==(0x0442+ 5722-0x1a9c))){return ((-
(0x16c8+ 697-0x1980)));}return ((0x05df+ 5030-0x1985));}sub 
checkForWaitingEventForPid{(my $pid=shift (@_));(my $childrenList=
$NXProcess::children);if (($pid==(-(0x1817+ 912-0x1ba6)))){foreach my $listpid (
keys (%$childrenList)){if (isChildFinished ($listpid)){return ($listpid);}else{
next;}}return ((0x01a3+ 3718-0x1029));}elsif (($pid>(0x0536+ 5791-0x1bd5))){if (
isChildProcess ($pid)){if (isChildFinished ($pid)){return ($pid);}else{return (
(0x04a2+ 7807-0x2321));}}else{if (isChildFinished ($pid)){return ($pid);}if (
isFinishedWatchDog ($pid)){return ($pid);}if (isOnWatchdogProcess ($pid)){return
 ((0x0885+ 422-0x0a2b));}return ((-(0x0386+ 5783-0x1a1c)));}}return ((-
(0x05c6+ 8476-0x26e1)));}sub nxwaitpid{(my $pid=shift (@_));(my $options=(shift 
(@_)||$NXBits::WAIT_NOHANG));(my $timeout=(shift (@_)||"\x69\x6e\x66"));(my $startwaitpid
=Common::NXTime::getSecondsSinceEpoch ());(my $sigpid=(-(0x076b+ 7510-0x24c0)));my (
$status);my ($nxplreturn);(my $finished=checkIsProcessFinished ($pid));if ((
$finished!=(0x0d7c+ 1072-0x11ac))){if (($finished==(-(0x0142+ 261-0x0246)))){
return ((-(0x21d6+ 1080-0x260d)));}return ($pid);}(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);if (($options==$NXBits::WAIT_UNTRACED)){while ((0x246b+  94-0x24c8)){
if (($timeout eq "\x69\x6e\x66")){Common::NXCore::exitFromSelectOnFirstSignal ()
;(my (@ready)=$selector->can_read);
Common::NXCore::disableExitFromSelectOnFirstSignal ();}else{if (($timeout<=
(0x084b+ 4838-0x1b31))){return ((0x052d+ 5869-0x1c1a));}
Common::NXCore::exitFromSelectOnFirstSignal ();(my (@ready)=$selector->can_read 
(($timeout *(0x142a+ 684-0x12ee))));
Common::NXCore::disableExitFromSelectOnFirstSignal ();($timeout=($timeout-(
Common::NXTime::getSecondsSinceEpoch ()-$startwaitpid)));}(my $check=
checkForWaitingEventForPid ($pid));if (((!$check)==(0x085a+ 6378-0x2144))){
return ($check);}}}else{(my (@ready)=$selector->can_read ((0x196f+ 688-0x1c1f),
"\x73\x69\x6c\x65\x6e\x74"));(my $waitingEvent=checkForWaitingEventForPid ($pid)
);return ($waitingEvent);}}sub nxChildProcessCheck{(my $pid=shift (@_));(my $status
=(0x0018+ 3230-0x0cb6));(my $exit=(0x1516+ 3302-0x21fc));my ($nxplreturn);(my $pidToNxpl
=convertToHandleIfNeeded ($pid));($nxplreturn=libnxh::NXProcessCheck ($pidToNxpl
,$status));if (($nxplreturn==(-(0x0905+ 4630-0x1b1a)))){(my $errname=
libnxh::NXGetErrorName ());Logger::warning (((((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x28".$pid)
."\x2f").$pidToNxpl).
"\x29\x20\x77\x69\x74\x68\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x68\x65\x63\x6b\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x72\x72\x6f\x72\x20\x27"
).$errname)."\x27\x2e"));}sub BEGIN{require POSIX;do{"\x50\x4f\x53\x49\x58"->
import ("\x3a\x73\x79\x73\x5f\x77\x61\x69\x74\x5f\x68")};}if (($nxplreturn==
(0x0a93+ 4765-0x1d30))){if (WIFEXITED ($status)){($exit=WEXITSTATUS ($status));
setChildExitCode ($pid,$exit);}if (WIFSIGNALED ($status)){($exit=WTERMSIG (
$status));setChildExitSignal ($pid,$exit);}}return ($nxplreturn);}sub sigterm{(my $process_pid
=shift (@_));if (libnxh::NXProcessRunning ($process_pid)){my ($result);if (
isChildProcess ($process_pid)){Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXProcessKill ($process_pid,$NXBITS::SIGTERM));}else{
Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXKillProcess ($process_pid,$NXBITS::SIGTERM));}if (($result
==(-(0x1545+ 2392-0x1e9c)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x11dc+ 3789-0x20a9));}else{Logger::debug (((((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$result)."\x2e"));return ((0x1581+ 2144-0x1de0));}}Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x17dd+ 2097-0x200d));}sub winKillTreeProcess{return (
(0x0b72+  99-0x0bd4));}sub sigkill{(my $process_pid=shift (@_));(my $process_tree
=(shift (@_)||(0x01fa+ 3668-0x104e)));if ((not (defined ($process_pid)))){
Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x0ed7+ 4130-0x1ef9));}if ((($process_pid==(0x1649+ 2657-0x20aa))or (
$process_pid==$ $))) {
 main::nxexit (getSignalKill ());}(my $pidToNxpl=
convertToHandleIfNeeded ($process_pid));(my $status=isProcessRunning (
$process_pid));if ($status){my ($return);if (isChildProcess ($process_pid)){
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalKill ()));}else{if ((
$process_tree==(0x17b7+ 3014-0x237d))){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalKill ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x74\x72\x65\x65\x2e"
));($return=libnxh::NXKillTree ($process_pid,getSignalKill ()));}}if (($return==
(-(0x1885+ 2878-0x23c2)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x252b+ 280-0x2643));}else{Logger::debug ((((((
("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid
)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x091a+ 4163-0x195c));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x0680+ 6564-0x2023));}sub sigSegv{(my $process_pid=shift (@_));if 
((not (defined ($process_pid)))){Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x0c73+ 4103-0x1c7a));}(my $pidToNxpl=convertToHandleIfNeeded (
$process_pid));(my $status=isProcessRunning ($process_pid));if ($status){my (
$return);if (isChildProcess ($process_pid)){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalSegv ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalSegv ()));}if (($return
==(-(0x0cf2+ 796-0x100d)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x53\x45\x47\x56\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x01e5+ 3289-0x0ebe));}else{Logger::debug (((((
(("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".
$process_pid)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x10f4+ 1446-0x1699));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x01da+ 1284-0x06dd));}sub signalProcessByRestrictedScript{(my $pid
=shift (@_));(my $signal=shift (@_));(my $tree=shift (@_));(my $nxkillScript=
"\x6e\x78\x6b\x69\x6c\x6c\x2e\x73\x68");(my (@command)=(
Common::NXCore::getNXExecCommand (),$nxkillScript,$pid,$signal,$tree));(my (
@parameters)=());main::run_command ((\@command),(\@parameters));}sub 
sendTerminateWaitAndKill{(my $processPid=shift (@_));(my $sleepTime=(shift (@_)
||(0x11c2+ 3317-0x1eb6)));if ((($processPid==(0x0b19+ 5036-0x1ec5))or (not (
defined ($processPid))))){Logger::debug (((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x27"
.$processPid)."\x27\x2e"));return ((0x071c+ 5030-0x1ac2));}if (isProcessRunning 
($processPid)){Logger::debug (((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20\x27\x31\x35\x27"));if 
(sigterm ($processPid)){Logger::debug (((
"\x53\x49\x47\x54\x45\x52\x4d\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime)
;if (isProcessRunning ($processPid)){if (sigkill ($processPid)){Logger::debug ((
(
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub leaveOrphans{foreach my $pid (keys (%$NXProcess::childrenToLeave)){(my $pidToNxpl
=convertToHandleIfNeeded ($pid));(my $result=libnxh::NXForceRemove ($pidToNxpl))
;if (($result==(-(0x0882+ 1118-0x0cdf)))){Common::NXCore::reportErrorFromNXPL ((
(((
"\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6f\x72\x63\x65\x20\x72\x65\x6d\x6f\x76\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2f").$pidToNxpl)."\x2e"));}else{Logger::debug (((((
"\x4c\x65\x66\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$pid)."\x2f").$pidToNxpl)
."\x20\x61\x73\x20\x6f\x72\x70\x68\x61\x6e\x2e"));}}foreach my $pid (keys (
%$NXProcess::watchDogList)){(my $result=libnxh::NXRemoveWatchdog ($pid));if ((
$result==(-(0x0d44+ 5873-0x2434)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2e"));}else{Logger::debug (((((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x20\x77\x69\x74\x68\x20\x72\x65\x73\x75\x6c\x74\x20\x27").$result).
"\x27\x2e"));}}}sub leaveChildAtFinish{(my $pid=shift (@_));if (isChildProcess (
$pid)){Logger::debug (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x20".$pid).
"\x20\x74\x6f\x20\x62\x65\x20\x6c\x65\x66\x74\x20\x61\x66\x74\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x65\x6e\x64\x73\x2e"
));($$NXProcess::childrenToLeave{$pid}=(0x0555+ 5407-0x1a73));}}sub 
leaveWatchdogAtFinish{(my $pid=shift (@_));($$NXProcess::watchDogToLeaveList{
$pid}=(0x0335+ 4720-0x15a4));}sub removeFromLeaveWatchdogAtFinishList{(my $pid=
shift (@_));delete ($$NXProcess::watchDogToLeaveList{$pid});}sub 
addToWatchDogList{(my $pid=shift (@_));($$NXProcess::watchDogList{$pid}=
(0x06d1+ 7069-0x226d));delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchDogSIG{foreach my $pid (keys (%$NXProcess::watchDogList)){
Logger::debug3 (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (
(("\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));
(my $callback=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x2e\x27"));delete ($$NXProcess::watchDogList{$pid});libnxh::NXRemoveWatchdog
 ($pid);($$NXProcess::finishedWatchDogList{$pid}=(0x1a0d+ 1166-0x1e9a));if ((
$callback ne (""))){&{$callback;}($pid,(0x0039+ 3665-0x0e8a));}}}}sub 
setCallbackSIGCHLD{(my $pid=shift (@_));(my $callback=shift (@_));(
$$NXProcess::childrenExitCallback{$pid}=$callback);(
$$NXProcess::childrenErrorCallback{$pid}=$callback);if (((not (isChildProcess (
$pid)))and (not (isOnWatchdogProcess ($pid))))){addToWatchDogList ($pid);}
Logger::debug2 ((((("\x4e\x65\x77\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x5b".
$$NXProcess::childrenExitCallback{$pid}).
"\x5d\x20\x66\x6f\x72\x20\x53\x49\x47\x43\x48\x49\x4c\x44\x20\x66\x6f\x72\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d"));}sub setExitCallback{(my $pid=shift (@_));(my $callback=shift (
@_));($$NXProcess::childrenExitCallback{$pid}=$callback);}sub setErrorCallback{(my $pid
=shift (@_));(my $callback=shift (@_));($$NXProcess::childrenErrorCallback{$pid}
=$callback);}sub addWatchdog{(my $pid=shift (@_));if (((not (defined ($pid)))or 
($pid==(0x0da1+ 3921-0x1cf2)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x61\x64\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid)."\x27\x2e"));return ((-(0x0014+ 6326-0x18c9)));}if (isOnWatchdogProcess (
$pid)){Logger::warning ((("\x50\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x6f\x6e\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6c\x69\x73\x74\x2e"
));return ((0x0e0d+   7-0x0e14));}Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x28"
.$pid)."\x2c\x20").$NXBITS::SIGCHLD)."\x29\x2e"));(my $result=
libnxh::NXAddWatchdog ($pid,$NXBITS::SIGCHLD));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$result)."\x27\x2e"));addToWatchDogList ($pid);setCallbackSIGCHLD ($pid,(
\&nxDefaultWatchdogExitHandler));return ((0x0e43+ 1750-0x1519));}sub addChild{(my $pid
=(shift (@_)||(0x02f1+ 4043-0x12bc)));if (($pid<=(0x0cd2+ 5496-0x224a))){
Logger::warning (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x77\x72\x6f\x6e\x67\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x2e"));return;}if ((not (isChildProcess ($pid)))){(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $nxplreturn=libnxh::NXProcessAdd ($pidToNxpl
));($$NXProcess::children{$pid}=(0x0d04+ 4099-0x1d06));Logger::debug (((((
"\x41\x64\x64\x65\x64\x20\x27".$pid)."\x2f").$pidToNxpl).
"\x27\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6c\x69\x73\x74\x2e"))
;($$NXProcess::childrenExitCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childrenErrorCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childFinishedWithSignal{$pid}=(0x0b63+ 5744-0x21d3));if (
isChildFinished ($pid)){delete ($$NXProcess::finishedChildren{$pid});}if (
isFinishedWatchDog ($pid)){delete ($$NXProcess::finishedWatchDogList{$pid});}}
else{Logger::debug (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x73\x61\x6d\x65\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x61\x73\x20\x63\x68\x69\x6c\x64\x2e"));}}sub 
nxDefaultExitCodeHandler{(my $pid=shift (@_));(my $code=shift (@_));
Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x45\x78\x69\x74\x43\x6f\x64\x65\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$pid)."\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub 
nxDefaultWatchdogExitHandler{(my $pid=shift (@_));Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x57\x61\x74\x63\x68\x64\x6f\x67\x45\x78\x69\x74\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x5b"
.$pid)."\x5d\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub removechild{(my $pid
=shift (@_));if (isChildProcess ($pid)){Logger::debug (((
"\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x20\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28"
.$pid)."\x29"));(my $pidToNxpl=convertToHandleIfNeeded ($pid));(my $nxplreturn=
libnxh::NXProcessRemove ($pidToNxpl));if (($nxplreturn==(-(0x181a+ 1757-0x1ef6))
)){Common::NXCore::reportErrorFromNXPL (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28".$pidToNxpl).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x2e"));}(my ($name,$lifetime)=
getChildNameAndLifetime ($pid));if (processTerminatedBySignal ($pid)){(my $exitSignal
=getChildExitSignal ($pid));if (($exitSignal!=$NXBITS::SIGTERM)){Logger::warning
 ((((((((((("\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}else{(my $exitCode=getChildExitCode (
$pid));if (($exitCode==(0x056f+ 3648-0x13af))){Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::warning (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}delete ($$NXProcess::children{$pid});
}if (exists ($$NXProcess::childrenToLeave{$pid})){delete (
$$NXProcess::childrenToLeave{$pid});}}sub isProcessRunning{(my $pid=shift (@_));
if (((not (defined ($pid)))or ($pid<=(0x03f2+ 6213-0x1c37)))){return (
(0x2270+ 309-0x23a5));}if (($pid==$ $)) {
 return ((0x010d+ 5725-0x1769));}if (
isChildProcess ($pid)){return ((0x02e2+ 222-0x03bf));}(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $ret=libnxh::NXProcessRunning ($pidToNxpl));
if (($ret==(-(0x046f+ 8292-0x24d2)))){(my $errname=libnxh::NXGetErrorName ());if
 ((($errname eq "\x45\x41\x43\x43\x45\x53")or ($errname eq 
"\x45\x50\x45\x52\x4d"))){return ((0x0643+ 933-0x09e7));}Logger::warning ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x65\x63\x6b\x20\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x75\x6e\x6e\x69\x6e\x67\x28"
.$pid)."\x2f").$pidToNxpl)."\x29\x20\x3a\x20").$errname));return (
(0x07d2+ 3968-0x1752));}return ($ret);}sub handleSIGUSR1{Logger::debug (
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x55\x53\x52\x31",(0x08fc+ 3490-0x169e));if
 (defined ($NXBegin::handlerSIGUSR1)){if (($NXBegin::handlerSIGUSR1 ne (""))){
Logger::debug (("\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x3a\x20".
$NXBegin::handlerSIGUSR1),(0x16b8+ 1260-0x1ba4));&$NXBegin::handlerSIGUSR1 ();}}
else{Logger::debug ("\x49\x67\x6e\x6f\x72\x69\x6e\x67\x20\x55\x53\x52\x31",
(0x0fca+ 1241-0x14a3));}}sub handleSIGCHLD{(my $children=$NXProcess::children);my (
$status);my ($nxplreturn);foreach my $listpid (keys (%$children)){Logger::debug3
 ((
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x43\x48\x4c\x44\x20\x63\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x3a\x20"
.$listpid),(0x0206+ 633-0x047f));($nxplreturn=nxChildProcessCheck ($listpid));
unless ($nxplreturn){removechild ($listpid);my ($callback);if ((
$$NXProcess::finishedChildren{$listpid}==(0x0aec+ 2842-0x1606))){($callback=
$$NXProcess::childrenExitCallback{$listpid});}else{($callback=
$$NXProcess::childrenErrorCallback{$listpid});}&{$callback;}($listpid,
$$NXProcess::finishedChildren{$listpid});}}handleWatchDogSIG ();
handleWatchdogAsSuperuserSIGCHLD ();}sub getExitValue{(my $pid=shift (@_));(my $exitValue
=$$NXProcess::finishedChildren{$pid});if ((not (defined ($exitValue)))){if ((not
 (isChildProcess ($pid)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x54\x68\x69\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));return ((0x1a90+ 781-0x1d9d));}else{Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x50\x72\x6f\x63\x65\x73\x73\x20\x73\x74\x69\x6c\x6c\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x05eb+ 7349-0x22a0));}}return ($exitValue);}sub isChildProcess{(my $pid
=shift (@_));if (exists ($$NXProcess::children{$pid})){return (
(0x148f+ 2246-0x1d54));}else{return ((0x0022+ 5829-0x16e7));}}sub 
isOnWatchdogProcess{(my $pid=shift (@_));if (exists ($$NXProcess::watchDogList{
$pid})){return ((0x0ca7+ 1496-0x127e));}else{return ((0x0827+ 1540-0x0e2b));}}
sub isChildFinished{(my $pid=shift (@_));if (exists (
$$NXProcess::finishedChildren{$pid})){return ((0x09d1+ 146-0x0a62));}else{return
 ((0x1380+ 4250-0x241a));}}sub isFinishedWatchDog{(my $pid=shift (@_));if (
exists ($$NXProcess::finishedWatchDogList{$pid})){return ((0x0397+ 3435-0x1101))
;}else{return ((0x08ed+ 4213-0x1962));}}sub processTerminatedBySignal{(my $pid=
shift (@_));if (($$NXProcess::childFinishedWithSignal{$pid}==
(0x01e0+ 6615-0x1bb6))){return ((0x0060+ 2830-0x0b6d));}else{return (
(0x0179+ 3696-0x0fe9));}}sub waitProcess{(my $pid=shift (@_));(my $timeout=shift
 (@_));my ($exitValue);my ($waitpidOption);my ($waitpidResult);my ($return);if (
($timeout gt (0x1617+ 1911-0x1d8e))){($waitpidOption=$NXBits::WAIT_UNTRACED);
Logger::debug (((((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x75\x73\x69\x6e\x67\x20").$timeout).
"\x73\x20\x61\x73\x20\x74\x69\x6d\x65\x6f\x75\x74"));}else{($waitpidOption=
$NXBits::WAIT_NOHANG);Logger::debug (((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27"));}unless ((isChildProcess ($pid)or isOnWatchdogProcess ($pid))){
Logger::debug (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$pid).
"\x20\x6e\x6f\x74\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x65\x64\x2c\x20\x61\x64\x64\x69\x6e\x67\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x2e"
));addWatchdog ($pid);}($waitpidResult=nxwaitpid ($pid,$waitpidOption,$timeout))
;if (($waitpidResult==$pid)){($exitValue=getStatusExited ());}elsif ((
$waitpidResult==(0x0d6c+ 4461-0x1ed9))){Logger::debug (((
"\x72\x65\x61\x63\x68\x65\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x6f\x66\x20".
$timeout).((
"\x73\x20\x77\x68\x69\x6c\x65\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27")));($exitValue=getStatusRunning ());}elsif (($waitpidResult==(-
(0x001f+ 4982-0x1394)))){Logger::debug (((
"\x6e\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
.$pid)."\x27\x20\x74\x6f\x20\x77\x61\x69\x74"));($exitValue=
getErrorNoProcessToWait ());}return ($exitValue);}sub getErrorNoProcessToWait{
return ($NXProcess::errorNoProcessToWait);}sub getStatusRunning{return (
$NXProcess::statusRunning);}sub getStatusExited{return ($NXProcess::statusExited
);}sub getSignalKill{return ($NXProcess::signalKill);}sub getSignalTerm{return (
$NXProcess::signalTerm);}sub getSignalSegv{return ($NXProcess::signalSegv);}sub 
getProcessTree{return ($NXProcess::processTree);}sub getNoProcessTree{return (
$NXProcess::noProcessTree);}sub registerChildName{(my $processName=shift (@_));(my $processPid
=shift (@_));(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x0324+ 754-0x0616),
(0x13c9+ 3785-0x228f)));Logger::debug2 (((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$processName).
"\x27\x20\x73\x74\x61\x72\x74\x65\x64\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
).$processPid).
"\x27\x20\x61\x74\x20\x74\x69\x6d\x65\x73\x74\x61\x6d\x70\x20\x27").$sec)."\x2c"
).$milisec)."\x27"));($$NXProcess::childrenData{$processPid}={});(
$$NXProcess::childrenData{$processPid}{"\x6e\x61\x6d\x65"}=$processName);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"}=$sec);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"}=$milisec);}
sub getChildNameAndLifetime{(my $pid=shift (@_));(my $childData=
$$NXProcess::childrenData{$pid});if (defined ($childData)){(my $name=$$childData
{"\x6e\x61\x6d\x65"});(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x155a+ 2708-0x1fee),
(0x0df9+ 3876-0x1d1a)));(my $startSeconds=$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"});(my $startMiliseconds=
$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"});(my $liveTimeSeconds
=($sec-$startSeconds));(my $liveTimeMiliseconds=($milisec-$startMiliseconds));if
 (($liveTimeMiliseconds<(0x00ba+ 9782-0x26f0))){($liveTimeMiliseconds=(
$liveTimeMiliseconds+(0x1969+ 973-0x194e)));($liveTimeSeconds=($liveTimeSeconds-
(0x027c+ 9089-0x25fc)));}(my $liveTime=(($liveTimeSeconds."\x2c").sprintf (
"\x25\x30\x33\x64",$liveTimeMiliseconds)));return ($name,$liveTime);}return (
(""),(0x0fd2+ 2069-0x17e7));}sub waitToTerminateOrKillIfStayAlive{(my $processPid
=shift (@_));(my $sleepTime=shift (@_));if (((not (defined ($processPid)))or (
$processPid<(0x03d7+ 2445-0x0d64)))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x61\x69\x74\x20\x74\x6f\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x20\x6f\x72\x20\x6b\x69\x6c\x6c\x20\x69\x66\x20\x73\x74\x61\x79\x20\x61\x6c\x69\x76\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x50\x49\x44\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x0a7f+ 6561-0x241f))
)){($sleepTime=(0x0560+ 8293-0x25c4));}if (isProcessRunning ($processPid)){
nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime);if (isProcessRunning (
$processPid)){if (sigkill ($processPid)){Logger::debug (((
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub waitToTerminateOrKillByScriptIfStayAlive{(my $processPid=shift (@_));(my $sleepTime
=shift (@_));if (((not (defined ($processPid)))or ($processPid<
(0x0886+ 1624-0x0ede)))){Logger::warning (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x69\x64\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x020a+ 5176-0x1641))
)){($sleepTime=(0x08f5+ 7276-0x2560));}if (isProcessRunning ($processPid)){(my $waitpid
=nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime));if (($waitpid!=
$processPid)){Logger::warning (((((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x66\x69\x6e\x69\x73\x68\x20\x77\x69\x74\x68\x69\x6e\x20"
).$sleepTime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x62\x79\x20\x72\x65\x73\x74\x72\x69\x63\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x2e"
));signalProcessByRestrictedScript ($processPid,getSignalKill ());}}else{
Logger::debug (((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub addWatchdogAsSuperuserOnWindows{Logger::warning (
"\x46\x75\x6e\x63\x74\x69\x6f\x6e\x20\x61\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x41\x73\x53\x75\x70\x65\x72\x75\x73\x65\x72\x4f\x6e\x57\x69\x6e\x64\x6f\x77\x73\x20\x63\x61\x6e\x20\x6f\x6e\x6c\x79\x20\x62\x65\x20\x72\x75\x6e\x20\x6f\x6e\x20\x57\x69\x6e\x64\x6f\x77\x73\x20\x73\x79\x73\x74\x65\x6d\x2e"
);return ((-(0x00ed+ 8392-0x21b4)));}sub addProcessToWatchdogAsSuperuserList{(my $pid
=shift (@_));(my $handle=shift (@_));($$NXProcess::watchDogAsSuperuser{$pid}=
$handle);delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchdogAsSuperuserSIGCHLD{foreach my $pid (keys (
%$NXProcess::watchDogAsSuperuser)){(my $handle=$$NXProcess::watchDogAsSuperuser{
$pid});Logger::debug3 (((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x77\x69\x74\x68\x20\x68\x61\x6e\x64\x6c\x65\x20\x27").$handle).
"\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (((
"\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27".
$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));(my $callback
=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x27\x2e"));delete ($$NXProcess::watchDogAsSuperuser{$pid});Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x68\x61\x6e\x64\x6c\x65\x20\x27".$handle).
"\x27\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"));(my $return
=libnxh::NXRemoveProcess ($handle));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x52\x65\x6d\x6f\x76\x65\x50\x72\x6f\x63\x65\x73\x73\x28"
.$handle)."\x29\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20\x27").$return).
"\x27\x2e"));if (($return==(-(0x04e9+ 6878-0x1fc6)))){
Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x68\x61\x6e\x64\x6c\x65\x20\x27"
.$handle).
"\x27\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"
));}($$NXProcess::finishedWatchDogList{$pid}=(0x02d4+ 7778-0x2135));if ((
$callback ne (""))){&{$callback;}($pid,(0x1ef9+ 663-0x2190));}}}}sub 
setChildExitCode{(my $pid=shift (@_));(my $code=shift (@_));(
$$NXProcess::finishedChildren{$pid}=$code);}sub getChildExitCode{(my $pid=shift 
(@_));if ((not (processTerminatedBySignal ($pid)))){return (
$$NXProcess::finishedChildren{$pid});}return (undef);}sub setChildExitSignal{(my $pid
=shift (@_));(my $sig=shift (@_));($$NXProcess::finishedChildren{$pid}=$sig);(
$$NXProcess::childFinishedWithSignal{$pid}=(0x1089+ 1806-0x1796));}sub 
getChildExitSignal{(my $pid=shift (@_));if (processTerminatedBySignal ($pid)){
return ($$NXProcess::finishedChildren{$pid});}return (undef);}sub 
getChildrenOfProcess{(my $pid=shift (@_));(my $commandPath=
Common::NXShellCommands::getPath ("\x70\x73"));if (($commandPath eq 
$Common::NXShellCommands::pathNotFound)){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid).
"\x27\x2e\x20\x50\x72\x6f\x67\x72\x61\x6d\x20\x27\x70\x73\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x70\x72\x65\x73\x65\x6e\x74\x20\x69\x6e\x20\x61\x20\x6b\x6e\x6f\x77\x6e\x20\x70\x61\x74\x68\x2e"
));return (());}(my (@command)=());(my (@options)=());push (@command,
$commandPath);push (@command,"\x2d\x2d\x70\x70\x69\x64",$pid);push (@command,
"\x2d\x6f");push (@command,"\x70\x69\x64\x3d");(my ($stderr,$stdout,$exitValue)=
main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x1108+ 1741-0x17d5))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid)."\x27\x2e"));return (());}($stdout=~ s/^\s+|\s+$//g );(my (@pids)=split ( /\s+/ ,
$stdout,(0x0c09+ 2071-0x1420)));return (@pids);}"\x3f\x3f\x3f";
