############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXDebugManager;no warnings;($__serverLogLevelKey=
"\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x4c\x65\x76\x65\x6c");(
$__webplayerLogLevelKey=
"\x57\x65\x62\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x4c\x65\x76\x65\x6c");(
$__agentLogCleanKey=
"\x53\x65\x73\x73\x69\x6f\x6e\x4c\x6f\x67\x43\x6c\x65\x61\x6e");(
$__syslogSupportKey=
"\x45\x6e\x61\x62\x6c\x65\x53\x79\x73\x6c\x6f\x67\x53\x75\x70\x70\x6f\x72\x74");
sub enable{(my $ref_parameters=shift (@_));if ((($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x61\x6c\x6c")or ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq ("")))){(my $result=__enableDebugAll (
$ref_parameters));warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}elsif (($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x73\x65\x72\x76\x65\x72")){(my $result=
__enableDebugServer ($ref_parameters));warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}elsif (($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"}eq "\x6e\x6f\x64\x65")){(my $result=__enableDebugNode
 ());warnIfSyslogEnabled ($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"});return (
$result);}elsif (($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq 
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72")){if (NXLicense::isHttpdSupportFeature ()
){(my $result=__enableDebugWebPlayer ());warnIfSyslogEnabled ($$ref_parameters{
"\x65\x6e\x61\x62\x6c\x65"});return ($result);}else{NXMsg::error (
"\x65\x53\x65\x72\x76\x69\x63\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,"\x6d\x61\x69\x6e","\x77\x65\x62\x70\x6c\x61\x79\x65\x72");}}elsif ((
$$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq "\x61\x67\x65\x6e\x74")){return (
__enableDebugAgent ());}elsif (($$ref_parameters{"\x65\x6e\x61\x62\x6c\x65"}eq 
"\x64\x61\x65\x6d\x6f\x6e")){my (%info);($info{"\x6c\x65\x76\x65\x6c"}=
Logger::getDebugLevel ());($info{"\x74\x69\x6d\x65\x6f\x75\x74"}=((
$GLOBAL::TimeoutToWaitForDaemonReady *(0x0df3+ 1741-0x10d8))*
(0x1f9f+ 1287-0x24a1)));NXClientSystemDaemons::askNXServerDaemonForSetLogLevel (
(\%info));NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x64\x61\x65\x6d\x6f\x6e");return;}return ((0x1479+ 797-0x1795));}sub disable{(my $ref_parameters
=shift (@_));if ((($$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq 
"\x61\x6c\x6c")or ($$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq ("")))){
return (__disableDebugAll ($ref_parameters));}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x73\x65\x72\x76\x65\x72")){return (
__disableDebugServer ($ref_parameters));}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x6e\x6f\x64\x65")){return (
__disableDebugNode ($ref_parameters));}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x77\x65\x62\x70\x6c\x61\x79\x65\x72")){if (
NXLicense::isHttpdSupportFeature ()){return (__disableDebugWebPlayer ());}else{
NXMsg::error (
"\x65\x53\x65\x72\x76\x69\x63\x65\x4e\x6f\x74\x41\x76\x61\x69\x6c\x61\x62\x6c\x65"
,"\x6d\x61\x69\x6e","\x77\x65\x62\x70\x6c\x61\x79\x65\x72");}}elsif ((
$$ref_parameters{"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x61\x67\x65\x6e\x74")){
return (__disableDebugAgent ());}elsif (($$ref_parameters{
"\x64\x69\x73\x61\x62\x6c\x65"}eq "\x64\x61\x65\x6d\x6f\x6e")){my (%info);($info
{"\x6c\x65\x76\x65\x6c"}=Logger::getInfoLevel ());($info{
"\x74\x69\x6d\x65\x6f\x75\x74"}=(($GLOBAL::TimeoutToWaitForDaemonReady *
(0x083c+ 7453-0x2171))*(0x1cbb+ 1017-0x20af)));
NXClientSystemDaemons::askNXServerDaemonForSetLogLevel ((\%info));NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x64\x61\x65\x6d\x6f\x6e");return;}return ((0x10e7+ 2781-0x1bc3));}sub 
__enableDebugAll{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__enableDebugDynamicallyForAll ();NXMsg::info 
(
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x2572+ 409-0x270a));}if ((__enableDebugServer ()==
(0x0de8+ 3950-0x1d56))){return ((0x0ce3+ 5861-0x23c8));}if ((__enableDebugNode 
()==(0x12d3+ 2596-0x1cf7))){return ((0x0a0d+ 2169-0x1286));}if (
NXLicense::isHttpdSupportFeature ()){if ((__enableDebugWebPlayer ()==
(0x0589+ 6703-0x1fb8))){return ((0x0590+ 3169-0x11f1));}}if ((__enableDebugAgent
 ()==(0x0f11+ 5021-0x22ae))){return ((0x0f50+ 5253-0x23d5));}return (
(0x05d5+ 2828-0x10e0));}sub __enableDebugServer{(my $ref_parameters=shift (@_));
if (defined ($$ref_parameters{"\x64\x79\x6e\x61\x6d\x69\x63"})){
__enableDebugDynamicallyForServers ();NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x03d2+ 1414-0x0957));}(my $key=
$__serverLogLevelKey);(my $value=Logger::getDebugLevel ());(my $error=(""));if (
main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x08c8+ 6394-0x21c1));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72",$error);return ((0x0810+ 6207-0x204f));}}sub 
__enableDebugNode{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__enableDebugDynamicallyForNodes ();
NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x0911+ 4224-0x1990));}(my $key=$__serverLogLevelKey);(my $value=
Logger::getDebugLevel ());(my $error=(""));if (main::changeNodeCfgKeySetError (
$key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x0639+ 8295-0x269f));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65",
$error);return ((0x0275+ 8561-0x23e6));}}sub __enableDebugWebPlayer{(my $key=
$__webplayerLogLevelKey);(my $value=Logger::getDebugLevel ());(my $error=(""));
if (main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72");return ((0x0052+ 3818-0x0f3b));}else{
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72",$error);return ((0x012a+  71-0x0171));}}
sub __enableDebugAgent{(my $key=$__agentLogCleanKey);(my $value="\x30");(my $error
=(""));if (main::changeNodeCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74");return ((0x1ef9+  13-0x1f05));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74",$error);return ((0x046f+ 8510-0x25ad));}}sub 
__disableDebugAll{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters{
"\x64\x79\x6e\x61\x6d\x69\x63"})){__disableDebugDynamicallyForAll ();NXMsg::info
 (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x021f+ 3221-0x0eb3));}if ((__disableDebugServer ()==
(0x0177+ 4721-0x13e8))){return ((0x0fca+  53-0x0fff));}if ((__disableDebugNode 
()==(0x0349+ 3808-0x1229))){return ((0x20f7+  26-0x2111));}if (
NXLicense::isHttpdSupportFeature ()){if ((__disableDebugWebPlayer ()==
(0x0cc6+ 2607-0x16f5))){return ((0x0986+ 6238-0x21e4));}}if ((
__disableDebugAgent ()==(0x0695+ 731-0x0970))){return ((0x023f+ 7508-0x1f93));}
return ((0x073a+ 5308-0x1bf5));}sub __disableDebugServer{(my $ref_parameters=
shift (@_));if (defined ($$ref_parameters{"\x64\x79\x6e\x61\x6d\x69\x63"})){
__disableDebugDynamicallyForServers ();NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x0515+ 2331-0x0e2f));}(my $key=
$__serverLogLevelKey);(my $value=Logger::getInfoLevel ());(my $error=(""));if (
main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72");return ((0x148d+ 4491-0x2617));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x73\x65\x72\x76\x65\x72",$error);return ((0x1891+ 3145-0x24da));}}sub 
__disableDebugNode{(my $ref_parameters=shift (@_));if (defined ($$ref_parameters
{"\x64\x79\x6e\x61\x6d\x69\x63"})){__disableDebugDynamicallyForNodes ();
NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x0759+ 2025-0x0f41));}(my $key=$__serverLogLevelKey);(my $value=
Logger::getInfoLevel ());(my $error=(""));if (main::changeNodeCfgKeySetError (
$key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65");
return ((0x06cc+ 1374-0x0c29));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72","\x6e\x6f\x64\x65",
$error);return ((0x2280+ 832-0x25c0));}}sub __disableDebugWebPlayer{(my $key=
$__webplayerLogLevelKey);(my $value=Logger::getInfoLevel ());(my $error=(""));if
 (main::changeServerCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72");return ((0x00e5+ 5144-0x14fc));}else{
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x65\x62\x70\x6c\x61\x79\x65\x72",$error);return ((0x0bd3+ 4785-0x1e84));}}
sub __disableDebugAgent{(my $key=$__agentLogCleanKey);(my $value="\x31");(my $error
=(""));if (main::changeNodeCfgKeySetError ($key,$value,(\$error))){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74");return ((0x1bff+ 1431-0x2195));}else{NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x61\x67\x65\x6e\x74",$error);return ((0x0729+ 5175-0x1b60));}}sub status{(my $serverNodeLogLevelKey
=$__serverLogLevelKey);(my $webplayerLogLevelKey=$__webplayerLogLevelKey);(my $agentLogCleanKey
=$__agentLogCleanKey);(my $disabled="\x64\x69\x73\x61\x62\x6c\x65\x64");(my $enabled
="\x65\x6e\x61\x62\x6c\x65\x64");(my $server="\x73\x65\x72\x76\x65\x72");(my $node
="\x6e\x6f\x64\x65");(my $webplayer="\x77\x65\x62\x70\x6c\x61\x79\x65\x72");(my $agent
="\x61\x67\x65\x6e\x74");(my $infoLevel=Logger::getInfoLevel ());my (
$serverLogLevel);my ($nodeLogLevel);my ($webplayerLogLevel);my ($agentLogClean);
(my $error=(""));(my $exitValue=(0x0ea7+ 2782-0x1985));(($exitValue,
$serverLogLevel)=main::getValueFromConfigFileSetError ($GLOBAL::CONFIG_FILE,
$serverNodeLogLevelKey,(\$error)));if (($exitValue==(0x0ca3+ 6386-0x2595))){
NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$error);}
elsif (($serverLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$enabled);}
else{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$server,$disabled);}
(($exitValue,$nodeLogLevel)=main::getValueFromConfigFileSetError (
$GLOBAL::NODE_CONFIG_FILE,$serverNodeLogLevelKey,(\$error)));if (($exitValue==
(0x0848+ 5046-0x1bfe))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$error);}elsif
 (($nodeLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$enabled);}else
{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$node,$disabled);}if 
(NXLicense::isHttpdSupportFeature ()){(($exitValue,$webplayerLogLevel)=
main::getValueFromConfigFileSetError ($GLOBAL::CONFIG_FILE,$webplayerLogLevelKey
,(\$error)));if (($exitValue==(0x1ac4+ 558-0x1cf2))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$error);}
elsif (($webplayerLogLevel>$infoLevel)){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$enabled);
}else{NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$webplayer,$disabled)
;}}(($exitValue,$agentLogClean)=main::getValueFromConfigFileSetError (
$GLOBAL::NODE_CONFIG_FILE,$agentLogCleanKey,(\$error)));if (($exitValue==
(0x0721+ 5913-0x1e3a))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$error);}
elsif (($agentLogClean eq "\x30")){NXMsg::info (
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$enabled);}
else{NXMsg::info ("\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$agent,$disabled);}
return ((0x072d+ 7634-0x24fe));}sub collect{Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x74\x61\x72\x74\x65\x64\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x4c\x6f\x67\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");(my (@filesToCleanUp
)=());(my $result=__runScriptsSetCleanUpFiles ((\@filesToCleanUp)));if (($result
==(0x0b78+ 1385-0x10e1))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");__cleanUpScriptLogs
 ((\@filesToCleanUp));return ((0x1098+ 1867-0x17e3));}($result=
__createZipArchive ());if (($result==(0x0112+ 1653-0x0787))){__cleanUpScriptLogs
 ((\@filesToCleanUp));NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");return (
(0x0752+ 5101-0x1b3f));}__cleanUpScriptLogs ((\@filesToCleanUp));Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x50\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x65\x64\x4c\x6f\x67\x73",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");warnIfSyslogEnabled 
();return ((0x0245+ 9007-0x2573));}sub __createZipArchive{NXMsg::info (
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x69\x6e\x67\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");(my (@paths)=());(my (
@names)=());(my $dateTime=Common::NXTime::getDateTimeForFileName ());(my $logFolderName
=("\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x2d\x6c\x6f\x67\x2d".$dateTime));
__setSpecialLogFolderPathAndName ((\@paths),(\@names),$logFolderName);
__setCommonLogFolderPathAndName ((\@paths),(\@names),$logFolderName);
__setAllUserLogFilesPathsAndNames ((\@paths),(\@names),$logFolderName);(my (
@excludePaths)=());push (@excludePaths,NXPaths::getLogArchivesPath ());push (
@excludePaths,NXPaths::getLogrotatePath ());(my $error=(""));(my $zipFile=
__getZipArchivePath ($logFolderName));(my $result=
Common::NXCore::createZipFileWithBestCompression ($zipFile,(\@paths),(\@names),(
\@excludePaths),(\$error)));if (($result!=(0x04c9+ 8745-0x26f1))){if (($result==
(-(0x1008+ 369-0x1178)))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$error);}else{NXMsg::warning (
"\x77\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x41\x70\x70\x65\x6e\x64\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$zipFile,Common::NXPaths::getNXServerLogPath ())
;}return ((0x0916+ 6985-0x245f));}else{NXMsg::info (
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x65\x64\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,"\x4e\x58\x53\x68\x65\x6c\x6c",$zipFile);}return ($result);}sub 
__cleanUpScriptLogs{(my $ref_cleanUpFiles=shift (@_));foreach my $file (
@$ref_cleanUpFiles){if ((Common::NXFile::fileExists ($file)and (not (unlink (
$file))))){Logger::warning ((((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20").$!));
Common::NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x52\x65\x6d\x6f\x76\x65\x46\x69\x6c\x65"
,$file,$!);}}}sub __getZipArchivePath{(my $logFolderName=shift (@_));(my $name=(
$logFolderName."\x2e\x7a\x69\x70"));(my $zipFile=((NXPaths::getLogArchivesPath 
().$GLOBAL::DIRECTORY_SLASH).$name));return ($zipFile);}sub 
__setSpecialLogFolderPathAndName{(my $ref_paths=shift (@_));(my $ref_names=shift
 (@_));(my $logFolderName=shift (@_));(my $logFolder=
Common::NXPaths::getSpecialUsersLogFolderPath ());push (@$ref_paths,$logFolder);
push (@$ref_names,$logFolderName);}sub __setCommonLogFolderPathAndName{(my $ref_paths
=shift (@_));(my $ref_names=shift (@_));(my $logFolderName=shift (@_));if ((
$GLOBAL::CommonLogDirectory ne (""))){push (@$ref_paths,
$GLOBAL::CommonLogDirectory);(my $commonLogName=($logFolderName.
"\x2f\x43\x6f\x6d\x6d\x6f\x6e\x4c\x6f\x67\x44\x69\x72\x65\x63\x74\x6f\x72\x79"))
;push (@$ref_names,$commonLogName);}}sub __setAllUserLogFilesPathsAndNames{(my $ref_paths
=shift (@_));(my $ref_names=shift (@_));(my $logFolderName=shift (@_));(my (
%users)=getUsersForLogCollection ());foreach my $user (keys (%users)){
__setUserLogFilesPathsAndNames ($user,$ref_paths,$ref_names,$logFolderName);}if 
(NXLicense::isHttpdSupportFeature ()){__setUserLogFilesPathsAndNames (
"\x6e\x78\x68\x74\x64",$ref_paths,$ref_names,$logFolderName);}}sub 
__getNxDirectoryInUserHomeDirectory{(my $user=shift (@_));if (($user eq 
"\x6e\x78\x68\x74\x64")){return (((
Common::NXPaths::getUserRealHomeDirectoryByUsername ($user).
$GLOBAL::DIRECTORY_SLASH)."\x2e\x6e\x78"));}else{return (
Common::NXPaths::getNxDirectoryInUserHomeDirectory ($user));}}sub 
__setUserLogFilesPathsAndNames{(my $user=shift (@_));(my $ref_paths=shift (@_));
(my $ref_names=shift (@_));(my $logFolderName=shift (@_));(my $nxDir=
__getNxDirectoryInUserHomeDirectory ($user));(my $nxserverLogPath=(($nxDir.
$GLOBAL::DIRECTORY_SLASH)."\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67"));(my $nodeDirPath
=(($nxDir.$GLOBAL::DIRECTORY_SLASH)."\x6e\x6f\x64\x65"));(my $nxserverLogName=(
$logFolderName.(("\x2f\x55\x73\x65\x72\x73\x2f".$user).
"\x2f\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67")));(my $nodeDirName=(
$logFolderName.(("\x2f\x55\x73\x65\x72\x73\x2f".$user)."\x2f\x6e\x6f\x64\x65")))
;if (Common::NXFile::fileExists ($nxserverLogPath)){push (@$ref_paths,
$nxserverLogPath);push (@$ref_names,$nxserverLogName);}if (
Common::NXFile::directoryExists ($nodeDirPath)){push (@$ref_paths,$nodeDirPath);
push (@$ref_names,$nodeDirName);}}sub __runScriptsSetCleanUpFiles{(my $ref_cleanUpFiles
=shift (@_));Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x74\x61\x72\x74\x65\x64\x20\x73\x74\x65\x70\x3a\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x2e"
);(my $scriptsFolderPath=NXPaths::getCollectLogScriptsPath ());(my (@scripts)=()
);(my $error=(""));(my $result=Common::NXCore::listSortedFilesInDirectory (
$scriptsFolderPath,(\@scripts),(\$error)));if (($result==(0x0de6+ 3578-0x1be0)))
{NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x4c\x69\x73\x74\x46\x69\x6c\x65\x73\x44\x69\x72\x65\x63\x74\x6f\x72\x79"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$scriptsFolderPath,
$error);return ((0x03bd+ 326-0x0503));}if (scalar (@scripts)){NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");}else{Logger::debug
 (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x42\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x20\x61\x72\x65\x20\x61\x62\x73\x65\x6e\x74\x2e"
);return ((0x11d8+ 1633-0x1838));}foreach my $script (@scripts){(my $scriptPath=
(($scriptsFolderPath.$GLOBAL::DIRECTORY_SLASH).$script));if ((not (-x (
$scriptPath)))){($result=
Common::NXFile::setPermissionFullForOwnerReadExecuteForAll ($scriptPath,(\$error
)));if (($result==(-(0x18f9+ 2347-0x2223)))){NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x50\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73"
,"\x4e\x58\x53\x68\x65\x6c\x6c",(($scriptPath."\x2e\x0a").$error));return (
(0x0ceb+ 4374-0x1e01));}}Logger::debug (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x52\x75\x6e\x6e\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.$scriptPath)."\x2e"));Common::NXMsg::info (
"\x69\x52\x75\x6e\x6e\x69\x6e\x67\x53\x63\x72\x69\x70\x74",$scriptPath);(my (
@command)=$scriptPath);(my (@parameters)=());push (@parameters,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");push
 (@parameters,
"\x73\x65\x74\x20\x73\x74\x64\x65\x72\x72\x20\x61\x73\x20\x70\x69\x70\x65");
__setEnvironmentVariablesForScript ((\@parameters));(my ($cmd_err,$cmd_out,
$exit_value)=main::run_command ((\@command),(\@parameters)));if ($exit_value){
Logger::error ((((((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x66\x6f\x72\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x73\x3a\x20"
.$scriptPath)."\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x3a\x20"
).$exit_value)."\x2c\x20").$cmd_err));NXMsg::error (
"\x65\x43\x4d\x44\x45\x78\x65\x63\x75\x74\x69\x6f\x6e\x4f\x66\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x46\x61\x69\x6c\x65\x64"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",$script,$cmd_err);
return ((0x0d27+ 4956-0x2083));}($script=~ s/\.[^\.]*$/.log/ );(my $scriptsLogFile
=((Common::NXPaths::getSpecialUsersLogFolderPath ().$GLOBAL::DIRECTORY_SLASH).
$script));($result=__saveScriptLogs ($scriptsLogFile,$cmd_out));if (($result==
(0x18b0+ 2963-0x2443))){return ((0x067f+ 241-0x0770));}push (@$ref_cleanUpFiles,
$scriptsLogFile);}Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x46\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x74\x65\x70\x3a\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x73\x63\x72\x69\x70\x74\x73\x2e"
);NXMsg::info (
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x45\x6e\x64"
,"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");return (
(0x2050+ 1215-0x250e));}sub __setEnvironmentVariablesForScript{(my $ref_parameters
=shift (@_));push (@$ref_parameters,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4e\x58\x5f\x42\x49\x4e\x5f\x50\x41\x54\x48\x3d".$GLOBAL::NODE_ROOT).
$GLOBAL::DIRECTORY_SLASH)."\x62\x69\x6e"));}sub __saveScriptLogs{(my $scriptLogFile
=shift (@_));(my $logs=shift (@_));(my $mode=($NXBits::O_CREAT+$NXBits::O_WRONLY
));(my $permissions=($NXBits::UserReadWrite+$NXBits::GroupReadWrite));(my $fd=
main::nxopen ($scriptLogFile,$mode,$permissions,{"\x45\x41\x43\x43\x45\x53",
"\x73\x69\x6c\x65\x6e\x74"}));if ((not (defined ($fd)))){Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20"
.$scriptLogFile).
"\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x73\x2e"
));(my $errorString=libnxh::NXGetErrorString ());(my $error=(($scriptLogFile.
"\x2c\x20").$errorString));Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",$error);return (
(0x0459+ 8158-0x2437));}if ((main::nxwrite ($fd,($logs."\x0a"))==(-
(0x01b8+ 1576-0x07df)))){Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x3a\x20"
.$scriptLogFile).
"\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x73\x63\x72\x69\x70\x74\x20\x6c\x6f\x67\x73\x2e"
));(my $errorString=libnxh::NXGetErrorString ());(my $error=(($scriptLogFile.
"\x2c\x20").$errorString));(my $path=Common::NXFile::dirname ($scriptLogFile));(my $file
=Common::NXFile::basename ($scriptLogFile));Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x57\x72\x69\x74\x65\x54\x6f\x46\x69\x6c\x65\x4f\x6e\x54\x68\x65\x4c\x6f\x63\x61\x6c\x48\x6f\x73\x74"
,$file,$path,$error);return ((0x1a20+ 212-0x1af4));}main::nxclose ($fd);return (
(0x0a74+ 6059-0x221e));}sub __enableDebugDynamicallyForAll{(my $product=
"\x61\x6c\x6c");(my $value=Logger::getDebugLevel ());Logger::updateLogLevel (
$value);return (__sendDebugLevel ($product,$value));}sub 
__enableDebugDynamicallyForServers{(my $product="\x73\x65\x72\x76\x65\x72");(my $value
=Logger::getDebugLevel ());Logger::updateLogLevel ($value);return (
__sendDebugLevel ($product,$value));}sub __enableDebugDynamicallyForNodes{(my $product
="\x6e\x6f\x64\x65");(my $value=Logger::getDebugLevel ());return (
__sendDebugLevel ($product,$value));}sub __disableDebugDynamicallyForAll{(my $product
="\x61\x6c\x6c");(my $value=Logger::getInfoLevel ());Logger::updateLogLevel (
$value);return (__sendDebugLevel ($product,$value));}sub 
__disableDebugDynamicallyForServers{(my $product="\x73\x65\x72\x76\x65\x72");(my $value
=Logger::getInfoLevel ());Logger::updateLogLevel ($value);return (
__sendDebugLevel ($product,$value));}sub __disableDebugDynamicallyForNodes{(my $product
="\x6e\x6f\x64\x65");(my $value=Logger::getInfoLevel ());return (
__sendDebugLevel ($product,$value));}sub __sendDebugLevel{(my $product=shift (@_
));(my $value=shift (@_));(my $message=((((($GLOBAL::MSG_DEBUG_LOG_LEVEL.
"\x20\x70\x72\x6f\x64\x75\x63\x74\x3d").$product)."\x20\x76\x61\x6c\x75\x65\x3d"
).$value)."\x20"));main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::publishToSubscribers ($message);}sub 
handleDebugLogLevelMessage{(my $message=shift (@_));my ($product);my ($value);if
 (($message=~ /product=(.*) value=(.*) $/ )){($product=$1);($value=$2);}else{
Logger::error (((
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x49\x6e\x63\x6f\x72\x72\x65\x63\x74\x20\x66\x6f\x72\x6d\x61\x74\x20\x66\x6f\x72\x20\x64\x65\x62\x75\x67\x20\x6c\x6f\x67\x20\x6c\x65\x76\x65\x6c\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27\x2e"));return ((0x1ce6+ 1791-0x23e5));}if (($product eq 
"\x73\x65\x72\x76\x65\x72")){Logger::updateLogLevel ($value);}elsif (($product 
eq "\x6e\x6f\x64\x65")){(my $nodeMessage=(("\x4e\x58\x3e\x20".$message)."\x0a"))
;NXNodeExec::sendToAllConnectedNodes ($nodeMessage);}elsif (($product eq 
"\x64\x61\x65\x6d\x6f\x6e")){if (Server::isDaemonProcess ()){
Logger::updateLogLevel ($value);main::nxrequire (
"\x50\x68\x79\x73\x69\x63\x53\x65\x73\x73\x69\x6f\x6e\x73");
PhysicSessions::updateLogLevel ($value);return ((0x047b+ 8454-0x2581));}}else{
Logger::updateLogLevel ($value);if (Server::isDaemonProcess ()){main::nxrequire 
("\x50\x68\x79\x73\x69\x63\x53\x65\x73\x73\x69\x6f\x6e\x73");
PhysicSessions::updateLogLevel ($value);}(my $nodeMessage=(("\x4e\x58\x3e\x20".
$message)."\x0a"));NXNodeExec::sendToAllConnectedNodes ($nodeMessage);}return (
(0x06db+ 1153-0x0b5b));}sub warnIfSyslogEnabled{(my $product=(shift (@_)||("")))
;if (__isSyslogEnabledForProduct ($product)){NXMsg::warning (
"\x77\x43\x4d\x44\x53\x79\x73\x6c\x6f\x67\x45\x6e\x61\x62\x6c\x65\x64",
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72");}}sub 
__isSyslogEnabledForProduct{(my $product=shift (@_));if (((($product eq 
"\x6e\x6f\x64\x65")or ($product eq "\x61\x6c\x6c"))or ($product eq ("")))){(my (
$exitValue,$nodeSyslog)=main::getValueFromConfigFile ($GLOBAL::NODE_CONFIG_FILE,
$__syslogSupportKey));if (($nodeSyslog eq "\x31")){return ((0x0227+ 8432-0x2316)
);}elsif (($product eq "\x6e\x6f\x64\x65")){return ((0x0053+ 2096-0x0883));}}if 
(($GLOBAL::EnableSyslogSupport eq "\x31")){return ((0x0f7a+ 5003-0x2304));}
return ((0x1756+  59-0x1791));}sub addUserForLogCollection{(my $user=shift (@_))
;if (($user ne (""))){NXRedis::sendToDb (((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x64\x65\x62\x75\x67\x75\x73\x65\x72\x73\x2c\x66\x69\x65\x6c\x64\x3d"
.$user)."\x2c\x76\x61\x6c\x75\x65\x3d").$user)."\x0a"));}else{Logger::debug (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x64\x6f\x20\x6e\x6f\x74\x20\x73\x65\x74\x20\x6c\x6f\x67\x20\x63\x6f\x6c\x6c\x65\x63\x74\x69\x6f\x6e\x20\x66\x6f\x72\x20\x65\x6d\x70\x74\x79\x20\x75\x73\x65\x72\x2e"
);}}sub getUsersForLogCollection{NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x67\x65\x74\x61\x6c\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x64\x65\x62\x75\x67\x75\x73\x65\x72\x73\x0a"
);return (split ( / / ,NXRedis::get (),(0x0055+ 5039-0x1404)));}
NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73",
(0x077c+ 8095-0x2397));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64",
(0x13e9+ 1906-0x17d7));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64",
(0x18f6+ 3322-0x226c));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x69\x6e\x67\x4c\x6f\x67\x73",
(0x1300+ 1450-0x1526));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x6f\x6c\x6c\x65\x63\x74\x65\x64\x4c\x6f\x67\x73",
(0x0eb0+ 4638-0x1d4a));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x53\x74\x61\x72\x74"
,(0x0c28+ 1986-0x1066));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x52\x75\x6e\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x73\x45\x6e\x64"
,(0x1b84+ 192-0x18c0));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x43\x72\x65\x61\x74\x69\x6e\x67\x4c\x6f\x67\x41\x72\x63\x68\x69\x76\x65"
,(0x0daa+ 902-0x0dac));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x45\x6e\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,(0x0d0a+ 7466-0x26b0));NXMsg::register_response (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x69\x43\x4d\x44\x44\x65\x62\x75\x67\x44\x69\x73\x61\x62\x6c\x65\x64\x44\x79\x6e\x61\x6d\x69\x63\x61\x6c\x6c\x79"
,(0x1a73+ 3603-0x2502));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x45\x6e\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,(0x115d+ 3141-0x1bae));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x44\x69\x73\x61\x62\x6c\x65\x44\x65\x62\x75\x67"
,(0x0450+ 4081-0x124d));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x44\x65\x62\x75\x67\x53\x74\x61\x74\x75\x73"
,(0x157c+ 2327-0x1c9f));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x45\x78\x65\x63\x75\x74\x69\x6f\x6e\x4f\x66\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x53\x63\x72\x69\x70\x74\x46\x61\x69\x6c\x65\x64"
,(0x1285+ 273-0x11a2));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x4c\x69\x73\x74\x46\x69\x6c\x65\x73\x44\x69\x72\x65\x63\x74\x6f\x72\x79"
,(0x1ad8+ 2637-0x2331));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6c\x6c\x65\x63\x74\x4c\x6f\x67\x73"
,(0x0885+ 6583-0x2048));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x47\x65\x74\x43\x66\x67\x4b\x65\x79\x56\x61\x6c\x75\x65"
,(0x08f1+ 4774-0x19a3));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x65\x43\x4d\x44\x44\x79\x6e\x61\x6d\x69\x63\x44\x65\x62\x75\x67\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,(0x140f+ 166-0x12c1));NXMsg::register_error (
"\x4e\x58\x44\x65\x62\x75\x67\x4d\x61\x6e\x61\x67\x65\x72",
"\x77\x43\x4d\x44\x53\x79\x73\x6c\x6f\x67\x45\x6e\x61\x62\x6c\x65\x64",
(0x105c+ 273-0x0f79));"\x3f\x3f\x3f";
