############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXPingManager;no warnings;(my $__pingRequestTime=(0x02a9+ 7559-0x2030));
(my $__pingTime=(0x0211+ 2878-0x0d4f));(my $__interval=(0x04dd+ 7630-0x22ab));(my $__timeout
=(0x0a39+ 5741-0x20a6));(my $__errorTimeout=(0x043c+ 1851-0x0b77));sub 
initialize{__setTimeBetweenPingsFromNode ();__setTimeoutForPingAfterRequest ();
__setPingRequestTime ();}sub __setTimeBetweenPingsFromNode{($__interval=
(0x0c40+ 1137-0x1066));Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x54\x69\x6d\x65\x20\x62\x65\x74\x77\x65\x65\x6e\x20\x70\x69\x6e\x67\x73\x20\x66\x72\x6f\x6d\x20\x74\x68\x65\x20\x6e\x6f\x64\x65\x3a\x20"
.$__interval)."\x2e"));}sub __setTimeoutForPingAfterRequest{($__timeout=
NXNodeConfiguration::getNodeConnectionTimeout ());Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x70\x69\x6e\x67\x20\x61\x66\x74\x65\x72\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$__timeout)."\x2e"));}sub checkTimesAndRequestPingIfNecessary{if ((
__isPingEnabled ()==(0x014b+ 1373-0x06a8))){return;}if ((__isTimeout ()==
(0x026a+ 8255-0x22a8))){if ((__isErrorTimeout ()==(0x00c9+ 7206-0x1cee))){(my $msg
=((
"\x4e\x6f\x64\x65\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x70\x69\x6e\x67\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x2e"
));Logger::error ($msg);Logger::statusPushError ($msg);die ($msg);}
__setErrorTimeout ();Logger::warning (((
"\x4e\x6f\x64\x65\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x70\x69\x6e\x67\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));__sendPingRequest ();
return;}if ((__isPingRequestTime ()==(0x0939+ 2634-0x1382))){__sendPingRequest 
();return;}}sub handlePing{Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);__resetPingRequestTime ();__clearErrorTimeout ();Logger::debug (
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x70\x6f\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_NODE_PONG)."\x20")
.$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_NODE_PONG})."\x0a"));__setPingTime ();}
sub __isPingRequestTime{if (($__pingTime==(0x049f+ 4611-0x16a2))){return (
(0x0aaa+ 4616-0x1cb2));}(my $time=Common::NXTime::getSecondsSinceEpoch ());if ((
$time>=($__pingTime+$__interval))){return ((0x1732+ 618-0x199b));}return (
(0x0f62+ 5241-0x23db));}sub __resetPingRequestTime{($__pingRequestTime=
(0x03e0+ 1285-0x08e5));}sub __setPingRequestTime{($__pingRequestTime=
Common::NXTime::getSecondsSinceEpoch ());}sub __sendPingRequest{Logger::debug (
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);NXNodeExec::sendToNode ((((("\x4e\x58\x3e\x20".$GLOBAL::MSG_REQUEST_FOR_PING).
"\x20").$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_REQUEST_FOR_PING})."\x0a"));
__setPingRequestTime ();__resetPingTime ();}sub disable{($__timeout=
(0x0d1b+ 746-0x1005));Logger::debug (
"\x4e\x58\x50\x69\x6e\x67\x4d\x61\x6e\x61\x67\x65\x72\x3a\x20\x44\x69\x73\x61\x62\x6c\x65\x20\x70\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x2e"
);}sub __isPingEnabled{if (($__timeout==(0x0259+ 1176-0x06f1))){return (
(0x0a6a+ 416-0x0c0a));}return ((0x1d05+ 226-0x1de6));}sub __isTimeout{if ((
$__pingRequestTime==(0x0d93+ 2335-0x16b2))){return ((0x249d+ 145-0x252e));}(my $time
=Common::NXTime::getSecondsSinceEpoch ());if (($__pingRequestTime>$time)){(
$__pingRequestTime=Common::NXTime::getSecondsSinceEpoch ());}if (($time>=(
$__pingRequestTime+$__timeout))){return ((0x0026+ 4469-0x119a));}return (
(0x0f7c+ 1413-0x1501));}sub __setPingTime{($__pingTime=
Common::NXTime::getSecondsSinceEpoch ());}sub __resetPingTime{($__pingTime=
(0x1151+ 3041-0x1d32));}sub __setErrorTimeout{($__errorTimeout=
(0x0d1d+ 6442-0x2646));}sub __isErrorTimeout{return ($__errorTimeout);}sub 
__clearErrorTimeout{($__errorTimeout=(0x232d+ 315-0x2468));}return (
(0x0f59+ 5852-0x2634));
