############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXStartup::BEGIN{package NXStartup;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}sub NXStartup::BEGIN{package NXStartup;no 
warnings;require NXRedis;do{"\x4e\x58\x52\x65\x64\x69\x73"->import};}sub 
NXStartup::BEGIN{package NXStartup;no warnings;require NXCluster;do{
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72"->import};}sub NXStartup::BEGIN{package 
NXStartup;no warnings;require Common::NXInfo;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x49\x6e\x66\x6f"->import};}package 
NXStartup;no warnings;require NXSystemDaemons;my (%__wasRunning);sub BEGIN{
require Error;do{"\x45\x72\x72\x6f\x72"->import ("\x3a\x74\x72\x79")};}sub 
handleStartup{if (Server::isDaemonProcess ()){handleStartupDaemon ();
main::nxexit ((0x183f+ 1472-0x1dff));}(my $isPossible=
libnxh::NXIsHostAddressResolvePossible ("\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74"))
;if (($isPossible!=(0x0382+ 7026-0x1ef3))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x6f\x6c\x76\x65\x20\x27\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x27\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x20\x68\x6f\x73\x74\x73\x20\x66\x69\x6c\x65\x20\x6f\x72\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x52\x65\x73\x6f\x6c\x76\x65\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x4e\x6f\x74\x50\x6f\x73\x73\x69\x62\x6c\x65"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");return;}main::nxrequire (
"\x4e\x58\x45\x47\x4c\x43\x61\x70\x74\x75\x72\x65");NXEGLCapture::processScripts
 ();(my $servicesToCheck=initializeStartup ());NXRedis::closeDb ();if ((
startNXServerDaemon ()==(0x1b5f+ 2710-0x25f4))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x115b+ 3622-0x1f81));}if ((
waitForDaemonReady ()==(0x02ad+ 4899-0x15cf))){Logger::warning (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x65\x61\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x65\x61\x64\x79\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x02d0+ 925-0x066d));}my (
$response);if ((Server::isCurrentServerDeamonStartedBySystemd ()or 
Server::isCurrentServerDeamonStartedByService ())){($response=
NXSystemDaemons::askServerDaemonForServiceStatus ($servicesToCheck));}else{(
$response=NXSystemDaemons::askServerDaemonForServiceStatusAndRunServicesIfNeeded
 ($servicesToCheck));}if (defined ($response)){NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73",
"\x65\x6e\x61\x62\x6c\x65\x64");NXSystemDaemons::printServiceStatusByReply (
$response,"\x73\x74\x61\x72\x74\x75\x70");}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x65\x73\x74\x61\x62\x6c\x69\x73\x68\x20\x63\x6f\x6d\x6d\x75\x6e\x69\x63\x61\x74\x69\x6f\x6e\x20\x77\x69\x74\x68\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x65\x61\x6d\x6f\x6e\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x06d8+ 3985-0x1669));}}sub 
handleStartupDaemon{if (NXLicense::isKillingLeftoverCMonStarup ()){
NXSession2::killAllRunningCM ();}NXSession2::cleanSessionsWithMyPid ();
NXServerDaemon::initializeDaemon ();if ((NXSystemDaemons::removeShutdownFlag ()
==(0x0356+ 3627-0x1180))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x66\x6c\x61\x67\x2e"
);return ((0x0df1+ 4731-0x206c));}removeServicesStopFlags ();
main::setSSHStatusStart ();NXUpdate::killUpdateIfPidFileExists ();
initializeNXUdp ();if (Server::startupNeedPerformAdministrativeTasks ()){
setFirewallRules ();}if (NXLicense::isHttpdSupportFeature ()){
NXSystemDaemons::stopServiceIfRunningWithoutNXServerDaemon (
"\x6e\x78\x68\x74\x64");}(my $isPossible=libnxh::NXIsHostAddressResolvePossible 
("\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74"));if (($isPossible!=
(0x14eb+ 3369-0x2213))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x6f\x6c\x76\x65\x20\x27\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x27\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x20\x68\x6f\x73\x74\x73\x20\x66\x69\x6c\x65\x20\x6f\x72\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);main::nxexit ((0x21ad+ 1122-0x260f));}NXServerDaemon::runDaemon ();}sub 
__checkServicesWithoutNXServerDaemon{NXMsg::info (
"\x69\x53\x65\x72\x76\x69\x63\x65\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73",
"\x6e\x78\x73\x65\x72\x76\x65\x72");NXSystemDaemons::printStatus (
"\x6e\x78\x6e\x6f\x64\x65");if (NXSystemDaemons::isNxdStartupKeyEnabled ()){
NXSystemDaemons::printStatus ("\x6e\x78\x64");}if ((
NXSystemDaemons::isServiceEnabled ("\x6e\x78\x68\x74\x64")and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){NXSystemDaemons::printStatus (
"\x6e\x78\x68\x74\x64");}}sub checkFixesAfterUpdate{(my $parameter=shift (@_));
if (($parameter ne "\x6d\x6f\x6e\x69\x74\x6f\x72")){
NXSystemDaemons::fixHttpdAfterUpdate ();NXSystemDaemons::fixNXpamAfterUpdate ();
NXSystemDaemons::fixUuidFile ();}}sub checkObfuscation{Logger::debug2 (
"\x42\x65\x67\x69\x6e\x69\x6e\x67\x20\x76\x65\x72\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x20\x6f\x66\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x2e"
);if ((libnxhs::NXPerlDirectoryObfuscation (($GLOBAL::NODE_ROOT.
"\x2f\x6c\x69\x62\x2f\x70\x65\x72\x6c\x2f\x6e\x78\x73\x65\x72\x76\x65\x72\x2f"))
!=(0x18cc+ 2311-0x21d2))){Logger::error (
"\x53\x65\x72\x76\x65\x72\x20\x63\x6f\x64\x65\x20\x69\x73\x6e\x27\x74\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x65\x64\x2e"
);NXMsg::send_response (
"\x65\x53\x65\x72\x76\x65\x72\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");exit ((0x0e2c+ 6265-0x26a5));}if ((
libnxhs::NXPerlDirectoryObfuscation (($GLOBAL::NODE_ROOT.
"\x2f\x6c\x69\x62\x2f\x70\x65\x72\x6c\x2f\x6e\x78\x6e\x6f\x64\x65\x2f"))!=
(0x01a9+ 2844-0x0cc4))){Logger::error (
"\x4e\x6f\x64\x65\x20\x63\x6f\x64\x65\x20\x69\x73\x6e\x27\x74\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x65\x64\x2e"
);NXMsg::send_response (
"\x65\x4e\x6f\x64\x65\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");exit ((0x0e4f+ 4536-0x2007));}
Logger::debug2 (
"\x46\x69\x6e\x69\x73\x68\x65\x64\x20\x76\x65\x72\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x20\x6f\x66\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x2e"
);}sub setLogFilesPermission{if (($ENV{"\x4e\x58\x5f\x51\x55\x49\x43\x4b"}eq 
"\x31")){return ((0x0fa6+ 2238-0x1864));}
Common::NXFile::setServerLogFilePermissions ();}sub delWebInfoFilesLeftover{if (
main::effectiveUserIsAdministrator ()){if (
NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()){main::nxrequire (
"\x4e\x58\x57\x65\x62\x49\x6e\x66\x6f\x46\x69\x6c\x65\x73\x43\x6f\x6e\x74\x72\x6f\x6c"
);NXWebInfoFilesControl::setInfoDirectoryPermissionByAdmin ();
NXWebInfoFilesControl::deleteAllInfoFiles ();}}}sub setUpdateFilePermission{if (
main::effectiveUserIsAdministrator ()){main::nxrequire (
"\x4e\x58\x55\x70\x64\x61\x74\x65");
NXUpdate::checkAndCorrectUpdateFilePermission ();}}sub 
__setErrorLogFilePermission{(my $nxerrorFile=NXPaths::getNXErrorFile ());if (($>
eq (0x08c1+ 2518-0x1297))){
Common::NXFile::setPermissionReadWriteForOwnerAndGroupWriteForAll ($nxerrorFile)
;}}sub setServerLogFilePermissionAndOwner{if ((not (Common::NXFile::isExists (
$lockFile)))){(my $nxlogFile=$GLOBAL::SystemLogFile);
Common::NXFile::setPermissionReadWriteForOwnerAndGroupWriteForAll ($nxlogFile);
Common::NXFile::setOwnershipForUserNXGroupRoot ($nxlogFile);}}sub 
checkUserNXRequirementsInPAM{(my $parameter=shift (@_));if (($parameter ne 
"\x6d\x6f\x6e\x69\x74\x6f\x72")){if ((not (__checkUserNXRequirementsInPAM ()))){
Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x75\x70\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x65\x72\x76\x69\x63\x65\x73\x2e\x20\x50\x41\x4d\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x69\x6f\x6e\x20\x61\x6c\x6c\x6f\x77\x73\x20\x75\x73\x65\x72\x73\x20\x66\x72\x6f\x6d\x20\x72\x6f\x6f\x74\x2f\x77\x68\x65\x65\x6c\x20\x67\x72\x6f\x75\x70\x20\x74\x6f\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x70\x61\x73\x73\x77\x6f\x72\x64"
);main::nxexit ((0x16fa+ 3237-0x239f));}}}sub __checkUserNXRequirementsInPAM{if 
((not (main::checkUserBelongsToGroupWheelOrRoot ("\x6e\x78")))){return (
(0x082c+ 5201-0x1c7c));}(my ($cmd_err,$cmd_out,$exit_value)=
Common::NXCore::run_setup ("\x63\x68\x65\x63\x6b\x70\x61\x6d","\x6e\x6f\x62\x67"
));if (($exit_value==(0x172b+ 2517-0x2100))){return ((0x02a9+ 8736-0x24c8));}
NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65",
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70","\x6e\x78\x73\x65\x72\x76\x65\x72");
return ((0x1220+ 231-0x1307));}sub killNXHtdIfRunningWithoutNXServerDaemonOnUnix
{if ((NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){
NXSystemDaemons::killNXHtdIfRunningWithoutNXServerDaemon ((0x0188+ 7749-0x1fcc))
;}}sub removeServicesStopFlags{NXSystemDaemons::removeStopFlag (
"\x6e\x78\x73\x65\x72\x76\x65\x72");if ((NXSystemDaemons::isNxdEnabled ()and 
NXSystemDaemons::isNxdStartupKeyEnabled ())){NXSystemDaemons::removeStopFlag (
"\x6e\x78\x64");}if ((NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){NXSystemDaemons::removeStopFlag (
"\x6e\x78\x68\x74\x64");}}sub disableServices{Common::NXCore::run_setup (
"\x64\x69\x73\x61\x62\x6c\x65\x73\x65\x72\x76\x69\x63\x65\x73",
"\x6e\x6f\x62\x67");}sub enableServices{Common::NXCore::run_setup (
"\x65\x6e\x61\x62\x6c\x65\x73\x65\x72\x76\x69\x63\x65\x73","\x6e\x6f\x62\x67");}
sub checkIfNetlogonServiceIsEnabled{();}sub checkIfHostnameContainNewLine{(my $hostInfo
=Common::NXInfo::getHostInfo ());if (($hostInfo=~ /\n/ )){Logger::error (
"\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x74\x61\x72\x74\x75\x70\x20\x77\x61\x73\x20\x69\x6e\x74\x65\x72\x72\x75\x70\x74\x65\x64\x2e\x20\x48\x6f\x73\x74\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x61\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x48\x6f\x73\x74\x6e\x61\x6d\x65\x43\x6f\x6e\x74\x61\x69\x6e\x73\x4e\x65\x77\x4c\x69\x6e\x65"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");main::nxexit ((0x028c+ 2480-0x0c3c));}}
sub setFirewallRules{main::nxrequire ("\x4e\x58\x46\x69\x72\x65\x77\x61\x6c\x6c"
);NXFirewall::addFirewallRules ();}sub startNXServerDaemon{if ((
NXServerDaemon::checkDaemonFlock ()==(0x0424+ 6652-0x1e20))){Logger::debug (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x0a2c+ 601-0x0c85));}if ((
Server::isCurrentServerDeamonStartedBySystemd ()or 
Server::isCurrentServerDeamonStartedByService ())){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);return (NXServices::NXDaemon::startDaemonOnLinux ());}main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);if (NXSystemDaemons::isSystemBasedOnSystemd ()){if ((not (
NXSystemDaemons::doesRunSystemdExist ()))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27\x2f\x72\x75\x6e\x2f\x73\x79\x73\x74\x65\x6d\x64\x27\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x65\x78\x69\x73\x74\x20\x6f\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x44\x69\x72\x52\x75\x6e\x53\x79\x73\x74\x65\x6d\x64\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");main::nxexit ((0x139a+ 3315-0x208d));}
NXServices::NXDaemon::startNXServerServiceBySystemd ();return (
(0x1ba1+ 1841-0x22d2));}elsif (NXSystemDaemons::startupRequrieUpStartSwitch ()){
if ((NXServices::NXDaemon::startNXServerServiceByUpStart ()!=
(0x2094+ 1242-0x256e))){Server::resetStartupNotNeedPerformAdministrativeTasks ()
;return (NXServices::NXDaemon::startDaemonOnLinux ());}return (
(0x15a0+ 2731-0x204b));}return (NXServices::NXDaemon::startDaemonOnLinux ());}
sub waitForDaemonReady{Logger::debug (
"\x53\x74\x61\x72\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x6f\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);(local $$NXBegin::parser{"\x73\x69\x67\x62\x61\x63\x6b"}{
"\x54\x45\x52\x4d"}=sub{Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x27\x53\x49\x47\x54\x45\x52\x4d\x27\x3a\x20\x65\x78\x69\x74\x2e"
);main::nxexit ((0x076c+ 426-0x0916));});(my $waitTime=(0x001f+ 5992-0x1787));(my $waitInterval
=(0x0a62+ 4100-0x1a02));(my $waitTimeout=__getTimeoutToWaitForDeamonReady ());(my $socketReady
=NXClientSystemDaemons::isSocketReady ());main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);while (($socketReady!=(0x10a8+ 1813-0x17bc))){if ((
NXServices::NXDaemon::isChildProcessNotWorking ()==(0x15a4+ 1137-0x1a14))){
Logger::debug (
"\x43\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x77\x6f\x72\x6b\x69\x6e\x67\x2c\x20\x73\x74\x6f\x70\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x17c9+ 266-0x18d2));}Logger::debug (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x6e\x6f\x74\x20\x72\x65\x61\x64\x79\x2c\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);($waitTime+=$waitInterval);if (($waitTime>$waitTimeout)){last;}$selector->
can_read ($waitInterval);($socketReady=NXClientSystemDaemons::isSocketReady ());
}if (($socketReady!=(0x1430+ 3710-0x22ad))){Logger::warning (((
"\x54\x69\x6d\x65\x6f\x75\x74\x20".$GLOBAL::TimeoutToWaitForDaemonReady).
"\x73\x20\x77\x68\x65\x6e\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
));return ((0x04a2+ 6504-0x1e09));}return ((0x02eb+ 346-0x0445));}sub 
initializeNXUdp{main::nxrequire (
"\x4e\x58\x55\x64\x70\x43\x6f\x6e\x74\x72\x6f\x6c");NXUdpControl::init ();}sub 
__getTimeoutToWaitForDeamonReady{return (($GLOBAL::TimeoutToWaitForDaemonReady *
(0x2471+ 782-0x2397)));}sub initializeStartup{(my $servicesToCheck=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x6e\x78\x6e\x6f\x64\x65\x20\x6e\x78\x64");
if (NXLicense::isHttpdSupportFeature ()){($servicesToCheck.=
"\x20\x6e\x78\x68\x74\x64");}($response=
NXSystemDaemons::askServerDaemonForServiceStatus ($servicesToCheck));if (defined
 ($response)){(my (@services)=split ( /, / ,$response,(0x1292+ 2533-0x1c77)));
foreach my $service (@services){if (($service=~ /(.*) Enabled/ )){($__wasRunning
{$1}=(0x0c00+ 5386-0x2109));}}removeServicesStopFlags ();return (
$servicesToCheck);}(my (@services)=split ("\x20",$servicesToCheck,
(0x0466+ 5416-0x198e)));foreach my $serviceName (@services){if (
NXSystemDaemons::isRunning ($serviceName)){($__wasRunning{$serviceName}=
(0x07c8+ 6956-0x22f3));}}return ($servicesToCheck);}sub serviceWasRunning{(my $service
=shift (@_));if ((defined ($__wasRunning{$service})and ($__wasRunning{$service}
==(0x100d+ 537-0x1225)))){return ((0x0b50+ 7007-0x26ae));}return (
(0x14f7+ 3699-0x236a));}NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x46\x69\x6e\x64\x4e\x65\x74\x4c\x6f\x67\x6f\x6e\x44\x65\x70\x65\x6e\x64\x65\x6e\x63\x79"
,(0x0368+ 8889-0x257f));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65\x43\x61\x6e\x74\x43\x6f\x6e\x6e\x65\x63\x74\x4d\x53\x47"
,(0x0e02+ 1639-0x1275));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65\x41\x75\x74\x68\x46\x61\x69\x6c\x65\x64\x4d\x53\x47"
,(0x13b0+ 1793-0x18bd));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x53\x65\x72\x76\x65\x72\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,(0x0ac8+ 5390-0x1de2));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x4e\x6f\x64\x65\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,(0x093d+ 1683-0x0ddc));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x52\x65\x73\x6f\x6c\x76\x65\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x4e\x6f\x74\x50\x6f\x73\x73\x69\x62\x6c\x65"
,(0x075f+ 2080-0x0d8b));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x48\x6f\x73\x74\x6e\x61\x6d\x65\x43\x6f\x6e\x74\x61\x69\x6e\x73\x4e\x65\x77\x4c\x69\x6e\x65"
,(0x134a+ 1479-0x171d));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x44\x69\x72\x52\x75\x6e\x53\x79\x73\x74\x65\x6d\x64\x4e\x6f\x74\x45\x78\x69\x73\x74"
,(0x02d5+ 5898-0x17eb));return ((0x07a9+ 2597-0x11cd));
