############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXServices::NXD;no warnings;(my $__pid=(0x16ef+ 3912-0x2637));(my $__disabled
=(0x0fec+ 3378-0x1d1e));(my $__startTime=(0x01c8+  62-0x0206));(my $__silenceMode
=(0x065a+ 1887-0x0db9));(my $__restartCouter=(0x0f39+ 4440-0x2091));(my $__stdin
=(-(0x0413+ 3942-0x1378)));(my $__handlingManualStart=(0x17cf+ 1225-0x1c98));(my $__status
=$NXSystemDaemons::statusUninitialized);sub isEnabled{if (($__disabled==
(0x00b0+ 7113-0x1c78))){Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x20\x62\x79\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0d77+ 5523-0x230a));}if (NXSystemDaemons::isServiceDisabled (
"\x6e\x78\x64")){Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x20\x62\x79\x20\x6c\x69\x63\x65\x6e\x73\x65\x20\x6f\x72\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x69\x6f\x6e\x2e"
);return ((0x0446+ 4162-0x1488));}if (NXSystemDaemons::isNxdStartupKeyDisabled 
()){if (__isHandlingManualStart ()){return ((0x1cea+ 2008-0x24c1));}
Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x69\x73\x20\x73\x65\x74\x20\x74\x6f\x20\x72\x75\x6e\x20\x6d\x61\x6e\x75\x61\x6c\x6c\x79\x2e"
);return ((0x04a9+ 5267-0x193c));}Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x69\x73\x20\x65\x6e\x61\x62\x6c\x65\x64\x2e"
);return ((0x0aa7+ 7183-0x26b5));}sub isDisabled{return ((!isEnabled ()));}sub 
setEnabled{($__disabled=(0x02c5+ 8444-0x23c1));}sub setDisabled{($__disabled=
(0x0c11+ 6157-0x241d));}sub start{if (($__status eq 
$NXSystemDaemons::statusStarting)){Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);return ((0x0475+ 5233-0x18e5));}if (isEnabled ()){
NXSystemDaemons::removeStopFlag ("\x6e\x78\x64");($__status=
$NXSystemDaemons::statusStarting);if ((NXSystemDaemons::isNxdStartupKeyDisabled 
()and __isHandlingManualStart ())){main::nxrequire (
"\x4e\x58\x46\x69\x72\x65\x77\x61\x6c\x6c");NXFirewall::addFirewallNXDPort ();}(my $nxdPid
=__runNXD ());if (Common::NXProcess::isProcessRunning ($nxdPid)){($__status=
$NXSystemDaemons::statusRunning);__handleNXDStartedWithPid ($nxdPid);return (
(0x0fc8+ 1756-0x16a3));}return ((0x1c54+ 2299-0x254f));}return (
(0x0165+ 5293-0x1611));}sub stop{NXSystemDaemons::setStopFlag ("\x6e\x78\x64");
setDisabled ();(my $ret=__closeNXD ());main::nxrequire (
"\x4e\x58\x53\x68\x75\x74\x64\x6f\x77\x6e");if ((($ret==(0x0336+ 2604-0x0d62))
and NXShutdown::serviceWasDisabled ("\x6e\x78\x64"))){setPid (
(0x01e5+ 2061-0x09f2));__handleNXDAlreadyClosed ();return ((0x0049+ 6950-0x1b6f)
);}elsif (($ret==(0x0e39+ 1803-0x1544))){setPid ((0x1c36+ 2671-0x26a5));
__handleNXDClosed ();return ((0x0bc8+ 2123-0x1413));}__handleNXDNotClosed ();
return ((0x1476+ 1988-0x1c39));}sub isSilenceMode{if (($__silenceMode==
(0x0b11+ 742-0x0df6))){return ((0x0b19+ 112-0x0b88));}if (
Server::isClientConnectionClosed ()){($__silenceMode=(0x155f+ 2451-0x1ef1));}
return ($__silenceMode);}sub setSilentMode{($__silenceMode=(0x1c88+ 822-0x1fbd))
;}sub __closeNXD{(my $nxdPid=getPid ());if ((($nxdPid==(0x006f+ 8285-0x20cc))or 
(not (Common::NXCore::isProcessRunnningAndExpectedNameMatchSilent ($nxdPid,
"\x6e\x78\x64"))))){return ((0x0620+ 6997-0x2175));}if (($__status eq 
$NXSystemDaemons::statusTerminating)){Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x2e"
);return ((0x07a7+ 7222-0x23dd));}($__status=$NXSystemDaemons::statusTerminating
);if ((Common::NXProcess::sigterm ($nxdPid)==(0x05e8+ 6512-0x1f57))){
NXSystemDaemons::waitForServiceClosure ($nxdPid,"\x6e\x78\x64");}if (
Common::NXCore::isProcessRunnningAndExpectedNameMatchSilent ($nxdPid,
"\x6e\x78\x64")){NXSystemDaemons::killServiceIfRunning ($nxdPid,"\x6e\x78\x64",
(0x08c4+ 4115-0x18d7));}else{return ((0x03e5+ 4720-0x1655));}if (
Common::NXCore::isProcessRunnningAndExpectedNameMatchSilent ($nxdPid,
"\x6e\x78\x64")){($__status=$NXSystemDaemons::statusTerminated);return (
(0x1e66+  75-0x1eb0));}return ((0x0a47+ 3866-0x1961));}sub __handleNXDClosed{if 
((not (isSilenceMode ()))){NXMsg::info (
"\x69\x53\x65\x72\x76\x69\x63\x65\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73","\x6e\x78\x64");}
NXSystemDaemons::removePidFile ("\x6e\x78\x64");main::nxrequire (
"\x4e\x58\x4c\x6f\x63\x61\x74\x65");NXLocate::requestToRemove ("\x6e\x78\x64");}
sub __handleNXDAlreadyClosed{if ((not (isSilenceMode ()))){NXMsg::info (
"\x69\x53\x65\x72\x76\x69\x63\x65\x41\x6c\x72\x65\x61\x64\x79\x44\x69\x73\x61\x62\x6c\x65\x64"
,"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73","\x6e\x78\x64");
}NXSystemDaemons::removePidFile ("\x6e\x78\x64");main::nxrequire (
"\x4e\x58\x4c\x6f\x63\x61\x74\x65");NXLocate::requestToRemove ("\x6e\x78\x64");}
sub __handleNXDNotClosed{if ((not (isSilenceMode ()))){NXMsg::info (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x6f\x70\x53\x65\x72\x76\x69\x63\x65",
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73","\x6e\x78\x64");}
}sub getPid{if (($__pid!=(0x0f3a+ 3060-0x1b2e))){Logger::debug (((
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x50\x49\x44\x20\x66\x72\x6f\x6d\x20\x6d\x65\x6d\x6f\x72\x79\x20"
.$__pid)."\x2e"));return ($__pid);}($__pid=NXSystemDaemons::readPid (
"\x6e\x78\x64"));return ($__pid);}sub setPid{($__pid=shift (@_));if (($__pid>
(0x0e43+ 5552-0x23f3))){NXSystemDaemons::savePid ("\x6e\x78\x64",$__pid);}}sub 
__setStartTime{($__startTime=Common::NXTime::getSecondsSinceEpoch ());}sub 
__handleNXDStartedWithPid{(my $nxdPid=shift (@_));
Common::NXProcess::setExitCallback ($nxdPid,(\&nxdSIGCHLDHandler));
Common::NXProcess::setErrorCallback ($nxdPid,(\&nxdSIGCHLDHandler));
Logger::debug (((
"\x4e\x58\x44\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$nxdPid)."\x2e"));__setStartTime ();setPid ($nxdPid);__resetHandlingManualStart
 ();main::nxrequire ("\x4e\x58\x4c\x6f\x63\x61\x74\x65");NXLocate::requestToAdd 
("\x6e\x78\x64");}sub __getStdoutFile{return ((((($GLOBAL::VAR_ROOT.
$GLOBAL::DIRECTORY_SLASH)."\x6c\x6f\x67").$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x64\x2e\x6c\x6f\x67"));}sub __getStderrFile{return (((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x6c\x6f\x67").
$GLOBAL::DIRECTORY_SLASH)."\x6e\x78\x64\x2e\x6c\x6f\x67"));}sub __runNXD{(my $servicePid
=getPid ());if ((($servicePid>(0x21bb+ 1032-0x25c3))and 
Common::NXCore::isProcessRunnningAndExpectedNameMatchSilent ($servicePid,
"\x6e\x78\x64"))){if (((not (Common::NXProcess::isChildProcess ($servicePid)))
and (not (Common::NXProcess::isOnWatchdogProcess ($servicePid))))){
Common::NXProcess::addWatchdog ($servicePid,$NXBITS::SIGCHLD);
Common::NXProcess::setCallbackSIGCHLD ($servicePid,(\&nxdSIGCHLDHandler));}
Logger::debug (
"\x4e\x58\x44\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ($servicePid);}if (($ENV{"\x4e\x58\x5f\x51\x55\x49\x43\x4b"}eq "\x31"))
{__createCertIfNeeded ();}(my (@command)=__getCommandStart ());(my (@options)=
__getCommandOptions ());my ($nxdPid);push (@options,
"\x67\x65\x74\x20\x70\x69\x64",(\$nxdPid));Logger::debug (
"\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6e\x78\x64\x2e");main::nxRunCommand ((
\@command),(\@options));return ($nxdPid);}sub __createCertIfNeeded{if (
Common::NXFile::isExists (NXPaths::getHostPrivateCert ())){return;}(my (@command
)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,"\x2d\x6b\x20");
push (@command,NXPaths::getHostPrivateCert ());push (@command,"\x2d\x63\x20");
push (@command,NXPaths::getHostPublicCert ());(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",((("\x4e\x58\x5f\x45\x54\x43\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x62\x69\x6e"));
main::nxRunCommand ((\@command),(\@options));}sub __getCommandStart{(my (
@command)=());push (@command,(((($GLOBAL::NODE_ROOT.$GLOBAL::DIRECTORY_SLASH).
"\x62\x69\x6e").$GLOBAL::DIRECTORY_SLASH)."\x6e\x78\x64"));if ((
NXNodeInfo::getNxdPort ()!=(0x1492+ 6248-0x1d5a))){push (@command,(
"\x2d\x70\x20".NXNodeInfo::getNxdPort ()));}if ((NXNodeInfo::getNxdUDPPort ()!=
(0x1346+ 7597-0x2153))){push (@command,("\x2d\x75\x20".NXNodeInfo::getNxdUDPPort
 ()));}if (($GLOBAL::NXdConnectionsLimit!=(""))){push (@command,("\x2d\x4c\x20".
$GLOBAL::NXdConnectionsLimit));}if (($GLOBAL::NXdConnectionsInterval!=(""))){
push (@command,("\x2d\x52\x20".($GLOBAL::NXdConnectionsInterval *
(0x07fb+  27-0x042e))));}if (($GLOBAL::NXdConnectionsIntervalLimit!=(""))){push 
(@command,("\x2d\x43\x20".$GLOBAL::NXdConnectionsIntervalLimit));}if ((
$GLOBAL::NXdListenAddress ne (""))){push (@command,"\x2d\x6c",
$GLOBAL::NXdListenAddress);}return (@command);}sub __getCommandOptions{(my (
@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".(
$GLOBAL::NODE_ROOT."\x2f\x6c\x69\x62")));(my $homeDir=NXPaths::getUserNXHomeDir 
());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".
$homeDir));main::nxrequire ("\x4e\x58\x43\x6c\x75\x73\x74\x65\x72");if (
NXCluster::isEnabled ()){push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x43\x4c\x55\x53\x54\x45\x52\x3d".$GLOBAL::ClusterHost));}if (($ENV
{"\x4e\x58\x5f\x51\x55\x49\x43\x4b"}eq "\x31")){push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",((("\x4e\x58\x5f\x45\x54\x43\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x62\x69\x6e"));}my ($nxdStdin);
Common::NXCore::nxPipeCreateBi ((\$__stdin),(\$nxdStdin));push (@options,
"\x75\x73\x65\x20\x61\x73\x20\x73\x74\x64\x69\x6e",$nxdStdin);push (@options,
"\x6c\x65\x61\x76\x65\x20\x73\x74\x64\x69\x6e\x20\x6f\x70\x65\x6e");
Logger::debug ((("\x4e\x58\x44\x3a\x20\x53\x74\x64\x69\x6e\x20\x46\x44\x23".
$__stdin)."\x2e"));push (@options,"\x73\x74\x64\x65\x72\x72",__getStderrFile ())
;push (@options,"\x73\x74\x64\x6f\x75\x74",__getStdoutFile ());push (@options,
"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53\x3d".libnxh::NXTransGetEnvironment
 ("\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53")));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e\x3d".
libnxh::NXTransGetEnvironment ("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e")));
push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".$GLOBAL::NODE_ROOT));return (@options
);}sub getStdin{return ($__stdin);}sub nxdSIGCHLDHandler{(my $pid=shift (@_));(my $code
=shift (@_));Logger::debug (((((
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$pid).
"\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$code)."\x2e"));NXSystemDaemons::removePidFile ("\x6e\x78\x64");setPid (
(0x0cd0+ 5214-0x212e));if ((($GLOBAL::REQUEST_TERMINATE==(0x0b5f+ 377-0x0cd7))or
 NXSystemDaemons::isShutdownFlag ())){Logger::debug (
"\x4e\x6f\x74\x20\x72\x65\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x4e\x58\x44\x20\x64\x75\x72\x69\x6e\x67\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x2e"
);return ((0x0034+ 3750-0x0eda));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::sendNxdClosedEvent ();if (isDisabled ()){return;}if (
NXSystemDaemons::isStopFlag ("\x6e\x78\x64")){Logger::debug (
"\x53\x65\x72\x76\x69\x63\x65\x20\x4e\x58\x44\x20\x68\x61\x73\x20\x73\x74\x6f\x70\x20\x66\x6c\x61\x67\x2e"
);return;}if (__isMaximumRestartCounterReached ()){setDisabled ();return;}start 
();}sub __isMaximumRestartCounterReached{(my $lifeTime=(
Common::NXTime::getSecondsSinceEpoch ()-$__startTime));if (($lifeTime<
$GLOBAL::TooShortServiceLifeTime)){($__restartCouter+=(0x1b3b+ 324-0x1c7e));}
else{($__restartCouter=(0x12f6+ 1825-0x1a17));}if (($__restartCouter>
$GLOBAL::MaximumServiceRestartCounter)){Logger::warning (
"\x52\x65\x61\x63\x68\x65\x64\x20\x6d\x61\x78\x69\x6d\x75\x6d\x20\x4e\x58\x44\x20\x72\x65\x73\x74\x61\x72\x74\x20\x63\x6f\x75\x6e\x74\x65\x72\x2e"
);return ((0x086f+ 3607-0x1685));}return ((0x0036+ 8881-0x22e7));}sub 
setHandlingManualStart{($__handlingManualStart=(0x0995+ 2136-0x11ec));}sub 
__isHandlingManualStart{if (($__handlingManualStart==(0x0cd3+ 2366-0x1610))){
return ((0x13ca+ 3447-0x2140));}return ((0x0dd7+ 1529-0x13d0));}sub 
__resetHandlingManualStart{($__handlingManualStart=(0x0d5b+ 4980-0x20cf));}
return ((0x1349+ 4281-0x2401));
